/*
 * main.c
 */
#include "copyright.h"

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#ifdef hpux
#include <time.h>
#else hpux
#include <sys/time.h>
#endif hpux
#ifndef hpux
#include <sys/wait.h>
#endif hpux
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

jmp_buf env;

main(argc, argv)
int argc;
char **argv;
{
    int intrupt();
    int team, s_type;
    int pno;
    char *host = NULL;
    int usage = 0;
    int err = 0;
    char *name, *ptr, *cp, *rindex();
    char buf[80];
    struct passwd *pwent, *getpwuid();
    int passive=0;
    char *defaultsFile=NULL;

	if( argc < 2 )
	{
		fprintf( stderr, "Usage:  %s <server name> [<port> 2592 ]\n", 
				argv[ 0 ] );
		exit(-1);
	}

	if( argc == 3 )
		xtrekPort=atoi( argv[ 2 ] );
	else
		xtrekPort=2592;
	
	serverName = argv[ 1 ];
	callServer(xtrekPort, serverName);
	openmem();
    findslot();
	getallplayers();
	playerlist();
}

getallplayers()
{
	while(( player_messages_count() < MAXPLAYER ) )
	{
		readFromServer();
	}
}

findslot()
{
    int oldcount= -1;

    /* Wait for some kind of indication about in/not in */
    while (queuePos == -1 )
	{
		socketPause();
		if (isServerDead()) 
		{
			printf("Augh!  Ghostbusted!\n");
			exit(0);
		}	
		readFromServer();
		if (me!=NULL )
		{
			/* We are in! */
			return(me->p_no);
		}	
    }
	printf("Queue with %d people ahead of us.\n", queuePos );
	exit( -1 );
}


static char *classes[NUM_TYPES] = {
	"SC", "DD", "CA", "BB", "AS", "SB", "  "
};

playerlist()
{
    int i,k;
    register struct player *j;
    int kills, losses;

    printf( "  Type Rank      Name             Login\n");

    for (k = FED; k <= ORI; k<<=1) {
	for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	    if (j->p_status == PALIVE && j->p_team == k) {
		printf("%c%c %s  %-9.9s %-16.16s %s@%s\n",
		       teamlet[j->p_team],
		       shipnos[j->p_no],
		       classes[j->p_ship.s_type],
		       ranks[j->p_stats.st_rank].name,
		       j->p_name, 
		       j->p_login, j->p_monitor );
	    }
	}
    }
}
